package com.chelvc.framework.database.interceptor;

import com.baomidou.mybatisplus.extension.plugins.handler.TenantLineHandler;
import com.chelvc.framework.database.entity.Environmental;
import com.chelvc.framework.database.support.MyBatisUtils;
import net.sf.jsqlparser.expression.Expression;

/**
 * 数据环境隔离处理拦截器
 *
 * @author Woody
 * @date 2024/6/12
 */
public class EnvIsolateInterceptor implements TenantLineHandler {
    @Override
    public Expression getTenantId() {
        return Expressions.env().getRight();
    }

    @Override
    public String getTenantIdColumn() {
        return Expressions.ENV_COLUMN.getColumnName();
    }

    @Override
    public boolean ignoreTable(String table) {
        if (Expressions.env().getLeft() == null) {
            return true;
        }
        Class<?> model = MyBatisUtils.getTableModel(table);
        return model == null || !Environmental.class.isAssignableFrom(model);
    }
}
